  Hangle = 0
  Mangle = 0
  Sangle = 0

fx = 0
fy = 0
fz = 0

HHand = 1
MHand = 1
SHand = 1


function gr1()
  
  local t = {}
  local t2 = {}
  
  local i,v
  local x,y,x1,y1,eplane,zplane
  
  
  local r,g,b,a = gr.getColor()

  
if HHand == 1 then 
  --=================================================================================
  -- short hand
  --=================================================================================
  --goto = L000
  ShortHand  = {
    {   -20,  -10   },
    {   100,  -10   },
    {   120,    0   },
    {   100,   10   },
    {   -20,   10   } 
  }  
  
  t = {}
  t2 = translate(ShortHand,{smxh,smyh})
  
  
  if TestFlag == true then
    Hangle = Hangle  + (1/8)  if Hangle >= 360 then Hangle = Hangle % 360 end
  else
    local d1,d2
    d1 = os.date("%I")
    d2 = os.date("%M")
    Hangle = (d2/60 * 30) + (d1 / 12 * 360)  - 90
  end    
  
  
  for i,v in ipairs(t2) do
    x,y = rotate(v[1],v[2],smxh,smyh,Hangle)
    table.insert(t,{x,y})
  end
  
  eplane = 4 zplane = 0  
  fz = 2000 * sp1
  fx = smxh + 2000*sp2 -1000
  fy = smyh + 2000*sp3 -1000
  focalPoint = {fx,fy,fz}

  tt = projection(focalPoint,t,eplane,zplane) 
  
  --love.graphics.setBlendMode("alpha") 
  love.graphics.setBlendMode("subtractive")
  local lw = gr.getLineWidth()
  gr.setLineWidth(2)
  --gr.setColor(210,210,210,80)  gr.polygon("fill",g2(tt))
  gr.setColor(160,160,160,80)  gr.polygon("fill",g2(tt))
  gr.setColor(160,160,160,80)  gr.polygon("line",g2(tt)) 
  love.graphics.setBlendMode("alpha") 
  gr.setColor(200,200,0,255)    gr.polygon("fill",g2(t)) 
  gr.setColor(250,250,0,255)    gr.polygon("line",g2(t)) 
  gr.setLineWidth(lw)
  --=================================================================================
end

  
if MHand == 1 then  
  --=================================================================================
  -- long hand
  --=================================================================================
  
  LongHand  = {
    {   -20,  -6   },
    {   200,  -6   },
    {   220,    0   },
    {   200,   6   },
    {   -20,   6   } 
  }  
  
--  -- with these shape it seemes that polygon fill fails
--  LongHand  = {
--    {   -35,  -10   },
--    {   -25,  -10   },
--    {   -20,  -6   },
--    {   200,  -6   },
--    {   220,    0   },
--    {   200,   6   },
--    {   -20,   6   }, 
--    {   -25,   10   }, 
--    {   -35,   10   } 
--  }  
--  --------------------------------------------

  t = {}
  t2 = translate(LongHand,{smxh,smyh})
  
  if TestFlag == true then
    Mangle = Mangle  + (1 / 5)  if Mangle >= 360 then Mangle = Mangle % 360 end
  else
    local d1,d2
    d1 = os.date("%M")
    d2 = os.date("%S")
    Mangle = (d2/60 * 6) + (d1/ 60 * 360)  - 90
  end  
  
  
  for i,v in ipairs(t2) do
    x,y = rotate(v[1],v[2],smxh,smyh,Mangle)
    table.insert(t,{x,y})
  end
  
  eplane = 5  zplane = 0  
  fz = 2000 * sp1
  fx = smxh + 2000*sp2 -1000
  fy = smyh + 2000*sp3 -1000
  focalPoint = {fx,fy,fz}
  tt = projection(focalPoint,t,eplane,zplane) 
  
  --love.graphics.setBlendMode("alpha") 
  --love.graphics.setBlendMode("multiplicative") 
  love.graphics.setBlendMode("subtractive")
  local lw = gr.getLineWidth()
  gr.setLineWidth(1)
  --gr.setColor(210,210,210,80)  gr.polygon("fill",g2(tt))
  gr.setColor(160,160,160,80)  gr.polygon("fill",g2(tt))
  gr.setColor(160,160,160,80)  gr.polygon("line",g2(tt))
  love.graphics.setBlendMode("alpha") 
  gr.setColor(200,200,0,255)    gr.polygon("fill",g2(t))
  gr.setColor(250,250,0,255)    gr.polygon("line",g2(t))
  gr.setLineWidth(lw)
  --=================================================================================
end  
  
  
  
  
if SHand == 1 then   
    --=================================================================================
  -- seconds hand
  --=================================================================================


  SecondHand  = {
    {   -20,  -2  },
    {   224,  -2   },
    {   230, 0     },
    {   224,   2   },
    {   -20,   2   }
  }  


  t = {}
  t2 = translate(SecondHand,{smxh,smyh})
  
  if TestFlag == true then
    Sangle = Sangle  +  1/2   if Sangle >= 360 then Sangle = Sangle % 360 end
  else
    local d1
    d1 = os.date("%S")
    Sangle = d1 / 60 * 360  - 90
  end

  for i,v in ipairs(t2) do
    x,y = rotate(v[1],v[2],smxh,smyh,Sangle)
    table.insert(t,{x,y})
  end
  
  eplane = 6  zplane = 0  
  fz = 2000 * sp1
  fx = smxh + 2000*sp2 -1000
  fy = smyh + 2000*sp3 -1000
  focalPoint = {fx,fy,fz}
  tt = projection(focalPoint,t,eplane,zplane) 
  
  --love.graphics.setBlendMode("alpha") 
  --love.graphics.setBlendMode("multiplicative") 
  love.graphics.setBlendMode("subtractive")
  local lw = gr.getLineWidth()
  gr.setLineWidth(1)
  --gr.setColor(210,210,210,80)  gr.polygon("fill",g2(tt))
  gr.setColor(160,160,160,80)  gr.polygon("fill",g2(tt))
  gr.setColor(160,160,160,80)  gr.polygon("line",g2(tt))
  love.graphics.setBlendMode("alpha") 
  gr.setColor(200,200,0,255)    gr.polygon("fill",g2(t))
  gr.setColor(250,250,0,255)    gr.polygon("line",g2(t))
  gr.setLineWidth(lw)
  --=================================================================================
end 
  
  
  
  
  
  --=================================================================================
  -- center point
  --=================================================================================
  love.graphics.setBlendMode("subtractive")
  love.graphics.setBlendMode("alpha")
  gr.setColor(100,100,100,125)
  gr.circle("fill",smxh,smyh,8,20)
  gr.setColor(70,70,70,200)
  gr.circle("fill",smxh,smyh,6,20)
  gr.setColor(0,0,0,255)
  gr.circle("fill",smxh,smyh,3,20)
  --=================================================================================
  
  
  
  
  
  
  --=================================================================================
  -- draw quadrant
  --=================================================================================
  local CircleTable = {}
  local radius = 15
  local xp,yp
  
  local angle  = 0
  local angle1
  
  for angle=0,360-6,6 do
    
    local m = 0.2
    if (angle % 30) == 0 then 
      m = 0.6
    end    
    if (angle % 90) == 0 then 
      m = 1.0 
    end    
    
    CircleTable = {}
    for i=0,360,10 do
      xp = m * 1.5 * radius * math.cos( i/180*math.pi)
      yp = m * radius * math.sin( i/180*math.pi)
      table.insert (CircleTable,{xp,yp})
    end    
    
    angle1 = angle
    
    t = {}
    t2 = CircleTable
    for i,v in ipairs(t2) do
      x,y = rotate(v[1],v[2],0,0,angle1)
      table.insert(t,{x,y})
    end  
    
    local R1 = 270
    xp = R1 * math.cos( angle1/180*math.pi)
    yp = R1 * math.sin( angle1/180*math.pi)
    t = translate(t,{smxh+xp,smyh+yp})
    
    eplane = 10  zplane = 0  
    fz = 2000 * sp1
    fx = smxh + 2000*sp2 -1000
    fy = smyh + 2000*sp3 -1000
    focalPoint = {fx,fy,fz}
    tt = projection(focalPoint,t,eplane,zplane) 
    
    love.graphics.setBlendMode("subtractive")
    local lw = gr.getLineWidth()
    gr.setLineWidth(1)
    gr.setColor(160,160,160,80)  gr.polygon("fill",g2(tt))
    gr.setColor(160,160,160,80)  gr.polygon("line",g2(tt))
    love.graphics.setBlendMode("alpha") 
    gr.setColor(200,200,0,255)    gr.polygon("fill",g2(t))
    gr.setColor(250,250,0,255)    gr.polygon("line",g2(t))
    gr.setLineWidth(lw)
    
  end
  --=================================================================================
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  gr.setColor(r,g,b,a)
  
end


function g2(pts) 
  -- return tableOf single values from table of XYpoint
  -- need for graphics.polygon
  local t={}
  local i,v
  for i,v in ipairs(pts) do
      table.insert(t,v[1])
      table.insert(t,v[2])
  end
  return t
end


function projection(focalPoint,ptsXY,entityZPlane,projectionZPlane) 
  -- return table of ptsXY on planeZ=0 from tables of ptxXY
  
  local rt={}
  
  local ratio,zd,xd,yd
  local x,y,px,py
  local focalX,focalY,focalZ
  
  focalX=focalPoint[1]  focalY=focalPoint[2]  focalZ=focalPoint[3]
  
  local i,v
  local pz = entityZPlane
  
  for i,v in ipairs(ptsXY) do
  
    px = ptsXY[i][1]
    py = ptsXY[i][2]
  
    zd = (focalZ - pz)
    if zd == 0 then zd = 0.1 end
    
    ratio = (pz - projectionZPlane) / zd
    
    yd = (py - focalY) * ratio
    y = py + yd
    
    xd = (px - focalX) * ratio
    x = px + xd
  
    table.insert(rt,{x,y})
  
  end
  
  return rt 
  
end


function rotate (xi,yi, cx,cy,angle)
  local x,y,x1,y1,f
  f = angle / 180 * math.pi
  x = xi - cx
  y = yi - cy
  x1 = x * math.cos( f) - y * math.sin (f)
  y1 = y * math.cos( f) + x * math.sin (f)  
  x1 = x1 + cx
  y1 = y1 + cy
  return x1,y1
end


function translate(p,q)
  local f = p
  local o = q
  local t={}
  local i,v,x,y
  for i,v in ipairs(f) do
    x = f[i][1] + o[1]
    y = f[i][2] + o[2]
    table.insert(t,{x,y})
  end
  return t
end